<template>
  <div class="app-container">
    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
        type="primary"
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['qw:account:add']"
        >添加账号</el-button>
      </el-col>
       <right-toolbar showSearch.sync="false" @queryTable="getList"></right-toolbar>
    </el-row>
    <el-table border v-loading="loading" :data="accountList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <!-- <el-table-column label="序号"  type="index" align="center" /> -->
      <el-table-column label="账号id" align="center" prop="id" />
      <el-table-column label="企微账号" align="center" prop="account" />
      <el-table-column label="头像" align="center" width="120">
        <template slot-scope="scope">
          <el-popover
            placement="right"
            title=""
            trigger="hover"
          >
            <img slot="reference" :src="scope.row.avatar" width="70">
            <img :src="scope.row.avatar" style="max-width: 120px;">
          </el-popover>
        </template>
      </el-table-column>
      <el-table-column label="昵称" align="center" prop="nickName" />
      <el-table-column label="企业名称" align="center" prop="corpName" />
      <el-table-column label="审核状态" align="center" prop="isAudit" >
          <template slot-scope="scope">
              <el-tag prop="isAudit" v-for="(item, index) in isAuditOptions"  :type="scope.row.isAudit==-1?'danger':'success'"  v-if="scope.row.isAudit==item.dictValue">{{item.dictLabel}}</el-tag>
          </template>
      </el-table-column>
      <el-table-column label="在线状态" align="center" prop="authCheck" >
          <template slot-scope="scope">
              <el-tag prop="authCheck" v-for="(item, index) in authCheckOptions"  :type="scope.row.authCheck==0?'danger':'success'"  v-if="scope.row.authCheck==item.dictValue">{{item.dictLabel}}</el-tag>
          </template>
      </el-table-column>
      <!-- <el-table-column label="关联设备id" align="center" prop="deviceId" /> -->
      <el-table-column label="最近一次上线时间" align="center" prop="onlineTime" />
      <el-table-column label="最近一次下线时间" align="center" prop="offlineTime" />
      <el-table-column label="创建时间" align="center" prop="createTime" />
      <el-table-column label="设备是否可用" align="center" prop="availableDevice" >
          <template slot-scope="scope">
              <el-tag prop="availableDevice" v-for="(item, index) in availableOptions"  :type="scope.row.availableDevice==-1?'danger':'success'"   v-if="scope.row.availableDevice==item.dictValue">{{item.dictLabel}}</el-tag>
          </template>
      </el-table-column>
      <el-table-column label="备注" align="center" prop="remark" />
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            v-if="scope.row.availableDevice == -1"
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdateDevice(scope.row)"
          >更新设备</el-button>
           <el-button
            size="mini"
            type="text"
            icon="el-icon-offline"
            v-if="scope.row.authCheck == 1"
            @click="handleOffLine(scope.row)"
          >强制下线</el-button>
        </template>
      </el-table-column>
      
    </el-table>
    
    <!-- <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    /> -->

    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="120px">
        <el-form-item label="企微账号" prop="account">
          <el-input v-model="form.account" placeholder="请输入企微账号"   />
        </el-form-item>
        <el-form-item label="备注" prop="remark">
          <el-input v-model="form.remark"  type="textarea" :row="5"  />
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { listAccount, getAccount, delAccount, addAccount, auditAccount, exportAccount,updateDevice } from "@/api/qw/account";
import { qwLoginOut } from "@/api/qw/login";

import store from "@/store";
export default {
  name: "Account",
  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      companys:[],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      activeName:"1",
      // 企微功能账号管理表格数据
      accountList: [],
      isAuditOptions:[],
      availableOptions:[],
      authCheckOptions:[],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        account: null,
        passWord: null,
        phone: null,
        email: null,
        status: null,
        realName: null,
        nickName: null,
        companyId: null,
        deviceId: null,
        deptId: null,
        companyUserId: null,
        isAudit: 0,
      },
      // 表单参数
      form: {},
      auditForm:{
        id:null,
        isAudit: null,
        deviceId: null,
      },
      // 表单校验
      rules: {
        deviceId: [
          { required: true, message: "关联设备id不能为空", trigger: "blur" }
        ],
        isAudit: [
          { required: true, message: "是否审核不能为空", trigger: "blur" }
        ],
      }
    };
  },
  created() {
    this.getList();
    // getCompanyList().then(response => {
    //   this.companys = response.data;
    // });
    this.getDicts("common_audit").then((response) => {
      this.isAuditOptions = response.data;
    });
    this.getDicts("qw_device_status").then((response) => {
      this.availableOptions = response.data;
    });
    this.getDicts("qw_login_status").then((response) => {
      this.authCheckOptions = response.data;
    });
  },
  methods: {
    /** 查询企微功能账号管理列表 */
    getList() {
      this.loading = true;
      listAccount(this.queryParams).then(response => {
        this.accountList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        account: null,
        passWord: null,
        phone: null,
        email: null,
        createTime: null,

        remark: null,
        realName: null,
        nickName: null,
        companyId: null,
        deviceId: null,
        deptId: null,
        companyUserId: null,
        isAudit: null,
        updateTime: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加企微功能账号管理";
    },
    
    handleAudit(row) {
      this.reset();
      const id = row.id || this.ids
      getAccount(id).then(response => {
        this.form = response.data;
        this.form.companyName = row.companyName;
        this.form.companyUserName = row.companyUserName;
        this.form.isAudit="1"
        this.open = true;
        this.title = "账号审核";
      });
    },

   qwLoginOut(deviceId) {
      qwLoginOut(deviceId).then(response => {
         this.msgSuccess("操作成功");
         this.getList();
      });
    },
  
   /** 提交按钮 */
   submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          addAccount(this.form).then(response => {
            if (response.code === 200) {
              this.msgSuccess("提交至审核");
              this.open = false;
              this.getList();
            }
          });
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$confirm('是否确认删除企微功能账号管理编号为"' + ids + '"的数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return delAccount(ids);
        }).then(() => {
          this.getList();
          this.msgSuccess("删除成功");
        }).catch(function() {});
    },

    handleUpdateDevice(row) {
      const id = row.id || this.ids
      this.$confirm('是否确认重新生成编号为"' + id + '"的设备id项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return updateDevice(id);
        }).then(() => {
          this.getList();
          this.msgSuccess("变更成功");
        }).catch(function() {});
    },
    handleOffLine(row){
      const id = row.id || this.ids
      this.$confirm('确定强制下线吗?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
            qwLoginOut(row.deviceId);
        }).then(() => {
          this.getList();
          this.msgSuccess("操作成功");
        }).catch(function() {});
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$confirm('是否确认导出所有企微功能账号管理数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return exportAccount(queryParams);
        }).then(response => {
          this.download(response.msg);
        }).catch(function() {});
    }
  }
};
</script>
